int SPI_sync();

unsigned char cmd_read_signature(int address);
unsigned char cmd_read_program(int address);
unsigned char cmd_read_eeprom(int address);
unsigned char cmd_read_fuses();
unsigned char cmd_read_fusesH();
unsigned char cmd_read_lock();
unsigned char cmd_read_cal(unsigned char addr);

void cmd_chip_erase();
void cmd_write_program(int address, unsigned char data);
void cmd_write_page(int page);
void cmd_write_eeprom(int address, unsigned char data);
void cmd_write_fuses(unsigned char data);
void cmd_write_fusesH(unsigned char data);
void cmd_write_lock(unsigned char data);

char cmd_poll_rdy();
