#define PROGMEM __attribute__((__progmem__))

typedef void prog_void PROGMEM;
typedef char prog_char PROGMEM;
typedef unsigned char prog_uchar PROGMEM;
typedef int prog_int PROGMEM;
typedef long prog_long PROGMEM;
typedef long long prog_long_long PROGMEM;

#define LPM(addr) ({               \
        unsigned short __addr16 = (unsigned short)(addr); \
        unsigned char __result;                 \
        __asm__ (                               \
                "lpm %0, Z"                     \
                : "=r" (__result)               \
                : "z" (__addr16)                \
        );                                      \
        __result;                               \
 })


#define LPM_classic(addr) ({                \
        unsigned short __addr16 = (unsigned short)(addr); \
        unsigned char __result;                 \
        __asm__ (                               \
                "lpm" "\n\t"                    \
                "mov %0, r0"                    \
                : "=r" (__result)               \
                : "z" (__addr16)                \
                : "r0"                          \
        );                                      \
        __result;                               \
 })
